/* 
 * Copyright 2000 Sun Microsystems, Inc. All rights reserved.
 * Copyright 2000 Sun Microsystems, Inc. Tous droits rservs. 
 */

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;
import java.io.*;

public class IterationTag extends BodyTagSupport {
   private String name, type;
   private Iterator iterator;

   public void setName(String name) {
      this.name = name;
   }

   public void setType(String type) {
      this.type = type;
   }

   public void setGroup(Collection members) {
      if(members.size() > 0)
         iterator = members.iterator();
   }

   public int doStartTag() {
      if(iterator == null) 
         return SKIP_BODY;
      if(iterator.hasNext()) {
         pageContext.setAttribute(name, iterator.next());
         return EVAL_BODY_TAG;
      }
      else {
         return SKIP_BODY;
      }
   }

   public int doAfterBody() throws JspException {
      BodyContent body = getBodyContent();
      try {
         body.writeOut(getPreviousOut());
      } catch (IOException e) {
         throw new JspTagException("IterationTag: " + e.getMessage());
      }
      // clear up so the next time the body content is empty
      body.clearBody();
      if (iterator.hasNext()) {
         pageContext.setAttribute(name, iterator.next());
         return EVAL_BODY_TAG;
      } else {
         return SKIP_BODY;
      }
   }
}
